#ifndef ZMODELER_STRUCT_GLOBAL_INCLUDED
#define ZMODELER_STRUCT_GLOBAL_INCLUDED

/*****************************************************/
//      GLOBAL RESOURCES
/*****************************************************/
class DllExport GlobalResources
{
public:
  CPen*  PenThinBlack;
  CPen*  PenThinBlue;
  CPen*  PenThinGreen;
  CPen*  PenThinRed; 
  CPen*  PenThinDarkRed;
  CPen*  PenThinGray;
  CPen*  PenThinWhite;
  CPen*  PenThinBlueCreate;

  CFont*  MenuCaptionFont;
  CFont*  MenuActiveCaptionFont;
  CFont*  ViewsCaptionFont;

  CBrush* MenuForegroundBrush;
  CBrush* MenuActiveForegroundBrush;
  CPen*  MenuShadowPen;
  CPen*  MenuHighlightPen;
  
  CBrush* BackgroundBrush;
  CDC*  GridDC;      //might be unused
  CBitmap  *GridBitmap;  //might be unused
  CPen*  GridNormalPen;  //might be unused
  CPen*  GridTenthsPen;  //might be unused
  CPen*  GridAxisPen;  //might be unused


  COLORREF  //Global Colors
      MenuCaptionColor,
      MenuActiveColor,
      MenuShadow,
      MenuHighlight,
      MenuForegroundColor,
      MenuActiveForegroundColor,

      ViewsBackground,
      ViewsCaptionColor,
      ViewsActiveCaptionColor,

      GridNormalColor,
      GridTenthsColor,
      GridAxisColor,
      //drawing colors:
      ColBlack,
      ColBlue,
      ColGreen,
      ColRed,
      ColDarkRed,
      ColGray,
      ColWhite,
      ColDots;
  float  Unit;
  char  UnitName[16];

  BYTE  MenuFontHeight;

public:
  GlobalResources(){}
  void Init();
  void Done();
};

#endif
