//------------------------------------------------
// RACER DOF file definitions
//------------------------------------------------

//////////////////////////////////////////////////////////////
//	Shows a failure message.
long ShowFailMessage(CWnd* pwnd, char *errmsg, char *cause, UINT icon);


typedef struct
{
	DWORD	ID;
	long	length;

	long	ReadChunk(CFile* pFile){return pFile->Read(this, sizeof(*this));}
	long	WriteChunk(CFile* pFile){pFile->Write(this, sizeof(*this)); return length;}
	long	SkipChunk(CFile* pFile){pFile->Seek(length, CFile::current); return length;}
}DOFChunk;

typedef struct
{
	float ambient[4];
	float diffuse[4];
	float specular[4];
	float emission[4];
	float shininess; 
}DOFMat;

typedef struct
{
	float uvwUoffset;
	float uvwVoffset;
	float uvwUtiling;
	float uvwVtiling;
	float uvwAngle;
	float uvwBlur;
	float uvwBlurOffset; 
}DOFMatUV;

typedef struct
{
	signed short i1,i2,i3;
}DOFFace;

typedef struct
{
	long NumBursts;
	long* burstStart;
	long* burstCount;
	long* burstMtlID;
	long* burstVperP;//3
}DOFBurst;

typedef struct
{
	float x,y,z,nx,ny,nz,u,v;
}DOFvert;