#include <struct.h>
#include "resource.h"

extern CWinApp* pApp;

long CreateCustomCursors(z3dProcsSet* pSet, DWORD idNorm, DWORD idShift, DWORD idCtrl)
{
  if (!pSet || !pApp) return 0;
  pSet->hcNorm  = pApp->LoadCursor(idNorm);
  pSet->hcShift  = (0 == idShift) ? pSet->hcNorm : pApp->LoadCursor(idShift);
  pSet->hcCtrl  = (0 == idCtrl) ? pSet->hcNorm : pApp->LoadCursor(idCtrl);
  pSet->hcRBNorm  = pSet->hcNorm;
  pSet->hcRBShift  = pSet->hcShift;
  pSet->hcRBCtrl  = pSet->hcCtrl;
  return 0;
}

DWORD CALLBACK SingleCustomCursors(z3dProcsSet* pSet)
{  return CreateCustomCursors(pSet, IDC_PICK, IDC_PICKADD, IDC_PICKSUB);}
DWORD CALLBACK SeparatedCustomCursors(z3dProcsSet* pSet)
{  return CreateCustomCursors(pSet, IDC_PICK, IDC_PICKADD, IDC_PICKSUB);}
DWORD CALLBACK AllCustomCursors(z3dProcsSet* pSet)
{  return CreateCustomCursors(pSet, IDC_PICK, IDC_PICKADD, IDC_PICKSUB);}
DWORD CALLBACK NoneCustomCursors(z3dProcsSet* pSet)
{  return CreateCustomCursors(pSet, IDC_PICK, IDC_PICKADD, IDC_PICKSUB);}
DWORD CALLBACK InvertCustomCursors(z3dProcsSet* pSet)
{  return CreateCustomCursors(pSet, IDC_PICK, IDC_PICKADD, IDC_PICKSUB);}
DWORD CALLBACK UVMappedCustomCursors(z3dProcsSet* pSet)
{  return CreateCustomCursors(pSet, IDC_PICK, IDC_PICKADD, IDC_PICKSUB);}

DWORD CALLBACK QuadrCustomCursors(z3dProcsSet* pSet)
{  return CreateCustomCursors(pSet, IDC_SELECT, IDC_SELECTADD, IDC_SELECTSUB);}
DWORD CALLBACK CircleCustomCursors(z3dProcsSet* pSet)
{  return CreateCustomCursors(pSet, IDC_SELECT, IDC_SELECTADD, IDC_SELECTSUB);}
