/**************************************************************
/********  Zanoza Plugin: SELECTORS   (c) Oleg M.2000  *******
/*************************************************************/
#include <Struct.h>


CWinApp* pApp = NULL;
//////////////////////////////////////////////////////////////
//  DWORD Capabilities - a combination versions
DWORD CALLBACK Capabilities(long)
{
  return ZMODELER_BUILD_VERSION();
}


//////////////////////////////////////////////////////////////
//  DWORD Supports returns a combination of supported features
DWORD CALLBACK Supports(long)
{
  return Z3D_PLUGSUPPORTS_PROCESSING;
}

//////////////////////////////////////////////////////////////
//  DOOL DynamicLoading specifies whether the dll will be
//  loaded only when it's functions are needed.
//  You should NOT make it dynamic, if it is a processor-type.
DWORD CALLBACK DynamicLoading(long)
{
  return 0; // DLL will be loaded ones.
}

//////////////////////////////////////////////////////////////
//  DWORD PlaceType returns a DWORD, that indicates, where the
//  plugin gode will be placed. It can be MenuBAR, MainMenu
DWORD CALLBACK PlaceType(DWORD)
{
  return Z3D_PROCPLACE_MENUBAR;
}

//////////////////////////////////////////////////////////////
//  DWORD GetProcsAmount returns a number of IDENTICAL procedu-
//  res that will be placed in the same folder. I think there is
//  No limitation here... (256 is enough;)
DWORD CALLBACK GetProcsAmount(DWORD)
{
  pApp = AfxGetApp();
  return 9; //Single, Quard, Circle, Separated, All, None, Invert, By Material, UV Mapped
}


//////////////////////////////////////////////////////////////
//  GetMenuFolder writes a name of subfolder. It can be your
//  own folder. or it can be emty. There are some standart
//  folders for MenuBAR:
//    Create...
//    Modify...
//    Select...
//    Display...
char* CALLBACK GetMenuFolder(DWORD num)
{
  return "Select...";
  // You can specify folders like that:
  // "Create...\\3D Objects...\\Spheres...\0";
}


//////////////////////////////////////////////////////////////
//  CString GetProcsNames - returns a name of procs. That names
//  will be displayed and they well be used in GetProcAddress.
//    (NOTE!) If you want to use a name with a space "", than
//    use the underline. It will be converted when the procedure
//    is added to the Menu. (for proper displaying)...
char* CALLBACK GetProcName(DWORD num)
{
//Single, Quard, Circle, Separated, All, None, Invert
  if (num==0) return "Single";
  if (num==1) return "Quadr";
  if (num==2) return "Circle";
  if (num==3) return "Separated";
  if (num==4) return "All";
  if (num==5) return "None";
  if (num==6) return "Invert";
  if (num==7) return "By Material";
  if (num==8) return "UV Mapped";

  return NULL;
}


char* CALLBACK GetProcComment(DWORD num)
{
  if (num==0) return "Right-Click to select or deselect single object, vertex or face";
  if (num==1) return "Right-Click and drag to select. Hold CTRL to deselect and/or SHIFT for andvanced select";
  if (num==2) return "Right-Click and drag to select. Hold CTRL to deselect and/or SHIFT for andvanced select";
  if (num==3) return "Right-Click on vertex or face to select all nearest vertices or faces. Hold CTRL to deselect";
  if (num==4) return "Right-Click to select all objects, faces or vertices";
  if (num==5) return "Right-Click to deselect all objects, faces or vertices";
  if (num==6) return "Right-Click to invert selection";
  if (num==7) return "Click the button to select faces by material";
  if (num==8) return "Right-Click to select UV-mapped faces. Hold CTRL to deselect";
  return NULL;
}

DWORD CALLBACK ButtonPressType(DWORD num)
{
  if (num != 7)
    return Z3D_PROCTYPE_PRESSABLE;
  else 
    return Z3D_PROCTYPE_SINGLECALL;
}




